Java异常分类

一、基本概念

看java的异常结构图

 

 

Throwable是所有异常的根,java.lang.Throwable
Error是错误,java.lang.Error
Exception是异常,java.lang.Exception

 


二、Exception

一般分为Checked异常和Runtime异常,所有RuntimeException类及其子类的实例被称为Runtime异常,不属于该范畴的异常则被称为CheckedException。


①Checked异常

只有java语言提供了Checked异常,Java认为Checked异常都是可以被处理的异常,所以Java程序必须显示处理Checked异常。如果程序没有处理Checked异常,该程序在编译时就会发生错误无法编译。这体现了Java的设计哲学:没有完善错误处理的代码根本没有机会被执行。对Checked异常处理方法有两种

1 当前方法知道如何处理该异常,则用try...catch块来处理该异常。
2 当前方法不知道如何处理,则在定义该方法是声明抛出该异常。

 

package cn.xy.test;  
 
import java.io.IOException;  
 
/**  
 * Checked异常测试方法  
 * @author xy  
 *  
 */ 
public class CheckedExceptionMethods  
{  
    // 总异常类,既有checkedException又有RuntimeException,所以其中的checkedException必须处理  
    public void method1() throws Exception  
    {  
        System.out.println("我是抛出异常总类的方法");  
    }  
 
    // 捕获并处理这个异常  
    public void testMethod1_01()  
    {  
        try 
        {  
            method1();  
        }  
        catch (Exception e)  
        {  
            e.printStackTrace();  
        }  
    }  
 
    // 把异常传递下去  
    public void testMethod1_02() throws Exception  
    {  
        method1();  
    }  
 
    public void testMethod1_03() throws Exception  
    {  
        throw new Exception();  
    }  
 
    public void testMethod1_04()  
    {  
        try 
        {  
            throw new Exception();  
        }  
        catch (Exception e)  
        {  
            e.printStackTrace();  
        }  
    }  
 
    // checkedException典型代表IOException  
    public void method2() throws IOException  
    {  
        System.out.println("我是抛出IO异常的方法");  
    }  
 
    public void testMethod2_01()  
    {  
        try 
        {  
            method2();  
        }  
        catch (Exception e)  
        {  
            e.printStackTrace();  
        }  
    }  
 
    public void testMethod2_02() throws Exception  
    {  
        method2();  
    }  
 
} 

我们比较熟悉的Checked异常有

Java.lang.ClassNotFoundException
Java.lang.NoSuchMetodException
java.io.IOException

 

②RuntimeException

Runtime如除数是0和数组下标越界等,其产生频繁,处理麻烦,若显示申明或者捕获将会对程序的可读性和运行效率影响很大。所以由系统自动检测并将它们交给缺省的异常处理程序。当然如果你有处理要求也可以显示捕获它们。

 

 
package cn.xy.test;  
 
/**  
 * 运行时异常测试方法  
 * @author xy  
 *  
 */ 
public class RuntimeExcetionMethods  
{  
    public void method3() throws RuntimeException  
    {  
        System.out.println("我是抛出运行时异常的方法");  
    }  
 
    public void testMethod3_01()  
    {  
        method3();  
    }  
 
    public void testMethod1_02()  
    {  
        throw new RuntimeException();  
    }  
} 

我们比较熟悉的RumtimeException类的子类有

Java.lang.ArithmeticException
Java.lang.ArrayStoreExcetpion
Java.lang.ClassCastException
Java.lang.IndexOutOfBoundsException
Java.lang.NullPointerException


三、Error

当程序发生不可控的错误时,通常做法是通知用户并中止程序的执行。与异常不同的是Error及其子类的对象不应被抛出。

Error是throwable的子类,代表编译时间和系统错误,用于指示合理的应用程序不应该试图捕获的严重问题。

Error由Java虚拟机生成并抛出,包括动态链接失败,虚拟机错误等。程序对其不做处理。

本文出自 “IT徐胖子的专栏” 博客,请务必保留此出处http://woshixy.blog.51cto.com/5637578/1071966

转载于:https://my.oschina.net/vshcxl/blog/827649

表情包
插入表情
评论将由博主筛选后显示,对所有人可见 | 还能输入1000个字符
相关推荐
©️2020 CSDN 皮肤主题: 大白 设计师:CSDN官方博客 返回首页